import java.io.*;
import java.util.*;
import java.security.*;
//import org.bouncycastle.jce.provider.BouncyCastleProvider;
import java.security.cert.X509Certificate;

public class TestPKCS12 {
	public static void main (String[] args) {
		// CHARGEMENT DU FICHIER PKCS#12

		KeyStore ks = null;
		char[] password = null;

		//Security.addProvider(new BouncyCastleProvider());
		try {
			if (args.length ==0 ) {
				System.out.println("Usage : java TestPKCS12 fichier.p12");
				return;
			}

			// On recupere un objet permettant de gerer
			// les certificats pkcs12
			// Un KeyStore peut gerer plusieurs certificats...
			ks = KeyStore.getInstance("PKCS12");

			// Password pour les fichiers PKCS12 du tp
			password = "BjjRules".toCharArray();
			
			// On charge ici un seul certificat dans le KeyStore
			ks.load(new FileInputStream(args[0]), password);

		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("Erreur: fichier " + args[0] +
					" n'est pas un fichier pkcs#12 valide ou passphrase incorrect");
			return ;
		}
	
		// RECUPERATION DU COUPLE CLE PRIVEE/PUBLIQUE ET DU CERTIFICAT PUBLIC

		X509Certificate cert = null;
		PrivateKey privatekey = null;
		PublicKey publickey = null;

		try {
			// Ici, on recupere les alias contenus dans chaque certificat du
			// KeyStore
			Enumeration en = ks.aliases();
			String ALIAS = "";
			Vector vectaliases = new Vector();
			while (en.hasMoreElements())
				vectaliases.add(en.nextElement());
			String[] aliases = (String []) (vectaliases.toArray(new String[0]));
			for (int i = 0; i < aliases.length; i++)
				if (ks.isKeyEntry(aliases[i]))
				{
					ALIAS = aliases[i];
					break;
				}

			// Ici on affiche les renseignements du certificat correspondant au dernier
			// alias.
			System.out.println("Alias : "+ ALIAS);
			privatekey = (PrivateKey)ks.getKey(ALIAS, password);
			cert = (X509Certificate)ks.getCertificate(ALIAS);
			publickey = ks.getCertificate(ALIAS).getPublicKey();

			String[] infos_emetteur = cert.getIssuerDN().getName().split("(=|, )", -1);
			String[] infos_titulaire = cert.getSubjectDN().getName().split("(=|, )", -1);
			System.out.println("CommonName : " + infos_titulaire[3]);
			System.out.println("EmailAdresse : " + infos_titulaire[1] + "\n");
			System.out.println("Issueur : " + infos_emetteur[3] + "\n");


			System.out.println("Got them !");
			// Ici on affiche tout !

			System.out.println("ALL CONTENTS");
			System.out.println("----------------------------------------------------------");
			System.out.println(cert.toString());
		} catch (Exception e) {
			e.printStackTrace();
			return ;
		}
	}
}

